--- old/usr/src/cmd/mdb/common/modules/usba/usb.c	Sun Dec 14 23:31:18 2014
+++ new/usr/src/cmd/mdb/common/modules/usba/usb.c	Sun Dec 14 23:31:18 2014
@@ -98,7 +98,7 @@
 	usba_device2devinfo_cbdata_t	*cb_data =
 			    (usba_device2devinfo_cbdata_t *)cb_arg;
 
-	if ((cur_usb_dev = mdb_usba_get_usba_device(dip_addr)) == NULL) {
+	if ((cur_usb_dev = mdb_usba_get_usba_device(dip_addr)) == (uintptr_t)NULL) {
 		/*
 		 * If there's no corresponding usba_device_t, this dip isn't
 		 * a usb node.  Might be an sd node.  Ignore it.
@@ -182,7 +182,7 @@
 usba_list_walk_init(mdb_walk_state_t *wsp)
 {
 	/* Must have a start addr.  */
-	if (wsp->walk_addr == NULL) {
+	if (wsp->walk_addr == (uintptr_t)NULL) {
 		mdb_warn("not a global walk.  Starting address required\n");
 
 		return (WALK_ERR);
@@ -215,7 +215,7 @@
 	wsp->walk_addr = (uintptr_t)list_entry.next;
 
 	/* Check if we're at the last element */
-	if (wsp->walk_addr == NULL) {
+	if (wsp->walk_addr == (uintptr_t)NULL) {
 
 		return (WALK_DONE);
 	}
@@ -237,7 +237,7 @@
 int
 usb_pipe_handle_walk_init(mdb_walk_state_t *wsp)
 {
-	if (wsp->walk_addr == NULL) {
+	if (wsp->walk_addr == (uintptr_t)NULL) {
 		mdb_warn("not a global walk; usba_device_t required\n");
 
 		return (WALK_ERR);
@@ -403,7 +403,7 @@
 {
 	usba_list_entry_t	list_entry;
 
-	if (wsp->walk_addr != NULL) {
+	if (wsp->walk_addr != (uintptr_t)NULL) {
 		mdb_warn(
 		    "global walk only.  Must be invoked without an address\n");
 
@@ -437,7 +437,7 @@
 	char		pathname[MAXNAMELEN];
 	char		dname[MODMAXNAMELEN + 1] = "<unatt>"; /* Driver name */
 	char		drv_statep[MODMAXNAMELEN+ 10];
-	uint_t		usb_flag  = NULL;
+	uint_t		usb_flag  = 0;
 	boolean_t	no_driver_attached = FALSE;
 	uintptr_t	dip_addr;
 	struct dev_info	devinfo;
@@ -509,7 +509,7 @@
 
 	if (usb_flag & USB_DUMP_VERBOSE) {
 		int		i;
-		uintptr_t	statep = NULL;
+		uintptr_t	statep = (uintptr_t)NULL;
 		char		*string_descr;
 		char		**config_cloud, **conf_str_descr;
 		usb_dev_descr_t	usb_dev_descr;
@@ -717,7 +717,7 @@
 	}
 	local_debug_buf[debug_buf_size - 1] = '\0';
 
-	if (strlen(local_debug_buf) == NULL) {
+	if (strlen(local_debug_buf) == 0) {
 
 		return (DCMD_OK);
 	}
